<span *ngIf="!(currQuestion && currQuestion.content)">
  <i class="fa fa-2 fa-spinner fa-spin"></i>
</span>
 <ng-container *ngIf="currQuestion">
  <div class="d-flex justify-content-between" *ngIf="(currQuestion.score || currQuestion.score === 0)">
    <div class="bg-light text-primary">
      Score: {{ currQuestion.score }} (={{
        (currQuestion.scorePerc * 100).toFixed(1)
      }}%)
    </div>
    <div >
      <span class="bg-light text-secondary" *ngIf="currQuestion && currQuestion.hint">
        hint: {{ currQuestion.hint }}
      </span>
    </div>
  </div>
  <div
    *ngIf="!currQuestion.isScaleQuestion()"
    class="edgar-q-content"
    [innerHTML]="
      currQuestion.content
        ? sanitizer.bypassSecurityTrustHtml(currQuestion.content)
        : 'please wait...'
    "
  ></div>
<div *ngIf="currQuestion.isCodeLang() || currQuestion.isJSON() || currQuestion.isSQL()">
  <div class="row">
    <div class="col-6">
      Student's answer:
      <div class="edgar-overlap border">
        <code-mirror
          [questionType]="currQuestion.type"
          [initialCode]="currQuestion.studentAnswerCode"
          [cmSkin]="cmSkin"
          [readOnly]="true"
        >
        </code-mirror>
        <div *ngIf="currQuestion.manualComment" class="edgar-comment-overlap">
          <button
            class="btn btn-warning col-1 edgar-overlap-btn-w d-flex comment-popover"
            data-toggle="popover"
          >
            <div [innerHTML]="currQuestion.graderImage"></div>
            <h3><i class="fa fa-comment-dots"></i></h3>
          </button>
        </div>
      </div>
    </div>
    <div class="col-6">
      Correct answer:
      <code-mirror
        [questionType]="currQuestion.type"
        [initialCode]="currQuestion.correctAnswerCode"
        [cmSkin]="cmSkin"
        [readOnly]="true"
      >
      </code-mirror>
    </div>
  </div>

  <br />

  <div *ngIf="!currQuestion.isJSON()" class="row d-flex justify-content-center">
    <hr />
    <em>Hint: {{ currQuestion.hint }}</em>
    <br />
  </div>

  <div *ngIf="parsed_eval_data[currQuestion.ordinal]">
    <hr />
    <h3>Exam results obtained during submission evaluation:</h3>
    <div class="card card-body">
      <table class="edgar2">
        <tr>
          <th>#</th>
          <th>stdin</th>
          <th>stdout</th>
          <th>expected</th>
          <th>stderr</th>
          <th>percentage</th>
          <th>hint</th>
          <th>mode</th>
          <th>correct?</th>
        </tr>
        <tr
          *ngFor="
            let row of parsed_eval_data[currQuestion.ordinal];
            let i = index
          "
        >
          <td>{{ i + 1 }}</td>
          <td class="edgar-code">
            <pre>{{ row.input }}</pre>
          </td>
          <td class="edgar-code">
            <pre>{{ row.output }}</pre>
          </td>
          <td class="edgar-code">
            <pre>{{ row.expected }}</pre>
          </td>
          <td class="edgar-code">
            <pre>{{ row.stderr }}</pre>
          </td>
          <td class="edgar-code">{{ row.percentage }}</td>
          <td>{{ row.hint }}</td>
          <td>{{ row.mode }}</td>
          <td>{{ row.isCorrect }}</td>
        </tr>
      </table>
    </div>
  </div>
  <div class="container-fluid">
    <ul class="nav nav-tabs nav-justified" role="tablist">
      <li class="nav-item">
        <a
          class="nav-link active"
          data-toggle="tab"
          href="#tabstudent"
          role="tab"
        >
          <b>Student's result</b>
        </a>
      </li>
      <li class="nav-item">
        <a class="nav-link" data-toggle="tab" href="#tabteacher" role="tab">
          <b>Correct result</b>
        </a>
      </li>
    </ul>

    <div class="tab-content edgar-tab-content">
      <div class="tab-pane fade show active" id="tabstudent" role="tabpanel">
        <ng-container *ngIf="currQuestion.isRunnable()">
          <div class="row d-flex justify-content-center">
            <button
              class="btn btn-primary m-2"
              type="button"
              (click)="rerunStudent()"
            >
              Rerun student's code
            </button>
          </div>
        </ng-container>
        <ng-container *ngIf="currQuestion.isCodeLang()">
          <clang-result
            [isRevision]="true"
            [result]="getStudentResult()"
            [showHourglass]="getShowHourGlassStudent()"
          >
          </clang-result>
        </ng-container>
        <ng-container *ngIf="currQuestion.isJSON()">
          <json-result
            [isRevision]="true"
            [c_eval_data]="currQuestion.c_eval_data"
            [result]="getStudentResult()"
          >
          </json-result>
        </ng-container>
        <div *ngIf="currQuestion.isSQL() && getStudentResult()">
          <div *ngIf="getStudentResult().success">
            <grid [result]="getStudentResult()"></grid>
          </div>
          <div *ngIf="!getStudentResult().success">
            <div class="text-left alert alert-danger edgar-code">
              {{ getStudentResult().error.message }}
              <div *ngIf="getStudentResult().error.position">
                Position:
                {{ getStudentResult().error.position }}
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="tab-pane" id="tabteacher" role="tabpanel">
        <ng-container *ngIf="currQuestion.isRunnable()">
          <div class="row d-flex justify-content-center">
            <button
              class="btn btn-primary m-2"
              type="button"
              (click)="rerunCorrect()"
            >
              Rerun teacher's code
            </button>
          </div>
          <clang-result
            [isRevision]="true"
            [result]="getCorrectResult()"
            [showHourglass]="getShowHourGlassCorrect()"
          >
          </clang-result>
        </ng-container>
        <ng-container *ngIf="currQuestion.isJSON()">
          <json-result
            [isRevision]="true"
            [result]="getCorrectResult()"
          ></json-result>
        </ng-container>
        <div *ngIf="currQuestion.isSQL() && getCorrectResult()">
          <div *ngIf="getCorrectResult().success">
            <grid [result]="getCorrectResult()"></grid>
          </div>
          <div *ngIf="!getCorrectResult().success">
            <div class="text-left alert alert-danger edgar-code">
              {{ getCorrectResult().error.message }}
              <div *ngIf="getCorrectResult().error.position">
                Position:
                {{ getCorrectResult().error.position }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>



<question-multichoice
  *ngIf="currQuestion.isMultiChoice()"
  [currQuestion]="currQuestion"
>
</question-multichoice>
<question-review-true-false
  *ngIf="currQuestion.isTrueFalse()"
  [currQuestion]="currQuestion"
>
</question-review-true-false>

<question-review-ordered-elements
  *ngIf="currQuestion.isOrderedElements()"
  [currQuestion]="currQuestion"
>
</question-review-ordered-elements>

<question-review-connected-elements
  *ngIf="currQuestion.isConnectedElements()"
  [currQuestion]="currQuestion"
>
</question-review-connected-elements>

<question-review-diagram
  *ngIf="currQuestion.isDiagram()"
  [currQuestion]="currQuestion"
  [cmSkin]="cmSkin"
>
</question-review-diagram>


<scale-items
  *ngIf="currQuestion.isScaleQuestion()"
  [currQuestion]="currQuestion"
>
</scale-items>

<free-text
  *ngIf="currQuestion.type === 'Free text'"
  [currQuestion]="currQuestion"
  [cmSkin]="cmSkin"
>
</free-text>

<file-upload
  *ngIf="currQuestion.uploadedFiles"
  [currQuestion]="currQuestion"
>
</file-upload>

 </ng-container>
